#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "sub/SubWrapperHelper.h"
#include "SM_PubDataWrapper.h"
#include "SM_SubDataWrapper.h"
#include "dpc_sm/executable.h"

#include "SM_GeneralWrapper.h"


GeneralWrapper::GeneralWrapper(ara::log::Logger& mainLog) : 
_SM2Decision_Provide("dpc_sm/dpc_sm/SM2DecisionPPort" ,mainLog),
_DM2SM_Required("dpc_sm/dpc_sm/DM2SMRPort", mainLog),
_VED2SM_Required("dpc_sm/dpc_sm/VED2SMRPort", mainLog),
_DM2SMObjectTrim_Required("dpc_sm/dpc_sm/DM2SMObjectTrimRPort", mainLog),
_EM2SMLaneInfo_Required("dpc_sm/dpc_sm/EM2SMLaneInfoRPort", mainLog),
_EM2SMLeftLine_Required("dpc_sm/dpc_sm/EM2SMLeftLineRPort", mainLog),
_EM2SMLeftRoadEdge_Required("dpc_sm/dpc_sm/EM2SMLeftRoadEdgeRPort", mainLog),
_ODDInfo_Required("dpc_sm/dpc_sm/EM2SMODDInfoRPort", mainLog),
_EM2SMRMEgoLftLnegeometry_Required("dpc_sm/dpc_sm/EM2SMRMEgoLftLnegeometryRPort", mainLog),
_EM2SMRMEgoRgtLnegeometry_Required("dpc_sm/dpc_sm/EM2SMRMEgoRgtLnegeometryRPort", mainLog),
_EM2SMRMRdEdgeLftgeometry_Required("dpc_sm/dpc_sm/EM2SMRMRdEdgeLftgeometryRPort", mainLog),
_EM2SMRMRdEdgeRgtgeometry_Required("dpc_sm/dpc_sm/EM2SMRMRdEdgeRgtgeometryRPort", mainLog),
_EM2SMRMSMMessage_Required("dpc_sm/dpc_sm/EM2SMRMSMMessageRPort", mainLog),
_EM2SMRightLine_Required("dpc_sm/dpc_sm/EM2SMRightLineRPort", mainLog),
_EM2SMRightRoadEdge_Required("dpc_sm/dpc_sm/EM2SMRightRoadEdgeRPort", mainLog),
_CAN2SM_Required("dpc_sm/dpc_sm/CAN2SMRPort", mainLog)
{

    _SM2Decision_Provide.Init();
    _DM2SM_Required.Init();
    _VED2SM_Required.Init();
    _DM2SMObjectTrim_Required.Init();
    _EM2SMLaneInfo_Required.Init();
    _EM2SMLeftLine_Required.Init();
    _EM2SMLeftRoadEdge_Required.Init();
    _ODDInfo_Required.Init();
    _EM2SMRMEgoLftLnegeometry_Required.Init();
    _EM2SMRMEgoRgtLnegeometry_Required.Init();
    _EM2SMRMRdEdgeLftgeometry_Required.Init();
    _EM2SMRMRdEdgeRgtgeometry_Required.Init();
    _EM2SMRMSMMessage_Required.Init();
    _EM2SMRightLine_Required.Init();
    _EM2SMRightRoadEdge_Required.Init();
    _CAN2SM_Required.Init();
}

GeneralWrapper::~GeneralWrapper() {
    _DM2SM_Required.Destroy();
    _VED2SM_Required.Destroy();
    _DM2SMObjectTrim_Required.Destroy();
    _EM2SMLaneInfo_Required.Destroy();
    _EM2SMLeftLine_Required.Destroy();
    _EM2SMLeftRoadEdge_Required.Destroy();
    _ODDInfo_Required.Destroy();
    _EM2SMRMEgoLftLnegeometry_Required.Destroy();
    _EM2SMRMEgoRgtLnegeometry_Required.Destroy();
    _EM2SMRMRdEdgeLftgeometry_Required.Destroy();
    _EM2SMRMRdEdgeRgtgeometry_Required.Destroy();
    _EM2SMRMSMMessage_Required.Destroy();
    _EM2SMRightLine_Required.Destroy();
    _EM2SMRightRoadEdge_Required.Destroy();
    _CAN2SM_Required.Destroy();
}
